import java.lang.*;
import java.util.*;
import java.text.*;

/**
 * Klasse fr die Informationen einer Person
 *
 * @author Bernhard Fiser 0109815
 * @version 1.0
 */

public abstract class Person
{
	public String	vname;
	public String	nname;
	private int	alter;
	private int	kohle;
	private Date	now;

	/** Initialisierung eines Personenobjektes */
	public 		Person(String vname, String nname, int year, int kohle)
	{
		this.vname = vname;
		this.nname = nname;

		this.now = new Date();
		SimpleDateFormat f = new SimpleDateFormat("y");

		try { this.alter = Integer.parseInt(f.format(now)) + 2000;}
		catch (NumberFormatException e) { System.out.println("*** error converting string to int\n"); }

		this.alter -= year;
		this.kohle = kohle;

		if (this.alter < 0)
			System.out.println("*** Achtung Falsches Jahr angegeben");
	}

	/** Ausgabe des Personenobjektes auf stdout */
	public void	print()
	{
		System.out.println(this.vname + " " + this.nname + ", " + this.alter + ", " + this.getGehalt() + " (" + this.kohle + ")");
	}


	/** Gibt das Alter der Person zurck */
	public int	getAlter()
	{
		return(this.alter);
	}

	/** Berechnet den Gehaltszuschlag der Person */
	abstract int	getZuschlag();

	/** Gibt das Gehalt der Person zurck */
	public int	getGehalt()
	{
		return(this.kohle + this.getZuschlag());
	}
}


